<script setup lang="ts">
import Button from '@/lib/registry/new-york/ui/button/Button.vue';
import Input from '@/lib/registry/new-york/ui/input/Input.vue';
import Label from '@/lib/registry/new-york/ui/label/Label.vue';
import Separator from '@/lib/registry/new-york/ui/separator/Separator.vue';
import { getDB, type WasmFileOutputDocData } from '@/local_db/db';
import { getLogger } from '@/log';
import { onMounted, ref } from 'vue';
import {
  Collapsible,
  CollapsibleContent,
  CollapsibleTrigger,
} from '@/components/ui/collapsible';

const logger = getLogger('info');

const emit = defineEmits(['wasm-uploaded']);

export type WasmUploadedEmit = {
  file: File;
  name: string;
};

const wasmName = ref('');
const wasmFiles = ref<WasmFileOutputDocData[]>([]);
const selectedFile = ref<File | null>(null);
const uploadedParsersOpen = ref(false);

const onFileChange = (event: Event) => {
  selectedFile.value = (event.target as HTMLInputElement).files?.[0] || null;
  logger.info('File selected');
};

const uploadWasm = async () => {
  const file = selectedFile.value;
  if (file && wasmName.value) {
    const db = await getDB();
    const name = wasmName.value;
    await db.saveWasmFile(file, name);
    await fetchWasmFiles();
    emit('wasm-uploaded', { file, name } satisfies WasmUploadedEmit);
    wasmName.value = '';
    selectedFile.value = null;
    uploadedParsersOpen.value = true;
  }
};

const fetchWasmFiles = async () => {
  const db = await getDB();
  const docs = await Promise.all(await db.getWasmFiles());
  wasmFiles.value = docs;
};


const deleteWasmFile = async (filename: string) => {
  const db = await getDB();
  await db.deleteWasmFile(filename);
  await fetchWasmFiles();
};

const formatFileSize = (size: number) => {
  const units = ['B', 'KB', 'MB', 'GB'];
  let index = 0;
  while (size >= 1024 && index < units.length - 1) {
    size /= 1024;
    index++;
  }
  return `${size.toFixed(2)} ${units[index]}`;
};

const formatDate = (timestamp: number) => {
  const date = new Date(timestamp);
  return date.toLocaleString();
};


onMounted(fetchWasmFiles);

</script>

<template>
  <div class="space-y-3">
    <Separator class="my-2" />
    <Label for="wasm-file">Upload WASM file:</Label>
    <input id="wasm-file" type="file" accept=".wasm" @change="onFileChange" style="display: none;" />
    <Button onclick="document.getElementById('wasm-file').click()" variant="secondary">
      Choose file
    </Button>
    <div class="text-xs">{{ selectedFile?.name ?? 'nothing selected yet...' }}</div>
    <Input v-model="wasmName" type="text" placeholder="WASM name" />
    <Button @click="uploadWasm" variant="default">
      Upload
    </Button>

    <div v-if="wasmFiles.length > 0" class="mt-4">
      <Collapsible v-model:open="uploadedParsersOpen">
        <CollapsibleTrigger class="font-bold text-sm cursor-pointer">
          Uploaded Parsers <v-icon name="bi-chevron-compact-down" scale=".8" animation="wrench" hover="true"
            speed="fast" />
        </CollapsibleTrigger>
        <CollapsibleContent>
          <div class="grid grid-cols-1 gap-1">
            <div v-for="wasm in wasmFiles" :key="wasm.name" class="border rounded p-2.5  relative">
              <button @click="deleteWasmFile(wasm.name)" class="absolute  right-2 bottom-2">
                <v-icon name="bi-x-circle" scale="1.0" animation="spin" hover="true" />
              </button>
              <div class="font-bold text-sm cursor-pointer">
                <Collapsible>
                  <CollapsibleTrigger>
                    {{ wasm.name }} <v-icon name="bi-chevron-compact-down" scale=".8" animation="wrench" hover="true"
                      speed="fast" />
                  </CollapsibleTrigger>
                  <CollapsibleContent>
                    <div class="font-semibold text-xs">{{ wasm.filename }}</div>
                    <div class="font-thin text-xs">Size: {{ formatFileSize(wasm.attachment.size) }}</div>
                    <div class="font-thin text-xs">Last Modified: {{ formatDate(wasm.lastModified) }}</div>
                  </CollapsibleContent>
                </Collapsible>
              </div>
            </div>
          </div>
        </CollapsibleContent>
      </Collapsible>
    </div>
  </div>
</template>
